from libc.so

voc: libc
libc 1 import exit
libc 3 import write
libc 3 import read
libc 2 import open
libc 1 import close
libc 2 import chmod

libc variable buffer
libc variable file


forth
: bye   vector libc 0 exit ;
: emit  vector libc buffer c! 1 buffer 1 write drop ;
: type  vector libc 1 -rot write drop ;
: key   vector libc 1 buffer 1 read drop buffer c@ ;

: clear 27 emit s" [2J" type : home 27 emit s" [1;1H" type ;

: use vector ;
: reload vector ;
: save vector ;

loc:
  create fname 256 allot
  : erase fname 256 0 fill ;
 :: erase wsparse fname swap move ; is use

  : set-perm fname 438 libc chmod drop ;
  : open fname 66 libc open file ! ;
  : close libc file @ close drop ;

  : read-contents libc file @ ~ { there #-of-blocks 512 * } libc read drop ;
 :: open read-contents close ; is reload

  : write-contents libc file @ ~ { there #-of-blocks 512 * } libc write drop ;
 :: open set-perm write-contents close ; is save
;loc
: load use reload ;
