from kernel32.dll

voc: kernel32
kernel32     variable buffer
kernel32   1 import CloseHandle
kernel32   3 import OpenFile
kernel32   5 import ReadFile
kernel32   5 import WriteFile
kernel32   1 import SetConsoleTitleA
kernel32   1 import GetStdHandle
kernel32   1 import GetModuleHandleA
kernel32   2 import SetConsoleMode
kernel32   1 import ExitProcess
kernel32   2 import SetConsoleCursorPosition
kernel32   0 import GetCommandLineA
kernel32 -11 GetStdHandle constant stdout
kernel32 -10 GetStdHandle constant stdin

: bye  vector  kernel32 0 ExitProcess ;
: emit vector  kernel32 buffer c! stdout buffer 1 buffer cell+ 0 WriteFile drop ;
: type vector  kernel32 >r >r stdout r> r> buffer 0 WriteFile drop ;
: key  vector  kernel32 stdin buffer 1 buffer cell+ 0 ReadFile drop buffer c@ ;

: use vector ;
: reload vector ;
: save vector ;

loc:
  create fname 256 allot
  : erase fname 256 0 fill ;
  :: erase wsparse fname swap move ; is use
  variable #size              : size { #-of-blocks } 512 * #size ! ;

  variable current
  : close current @ kernel32 CloseHandle drop ;

  $0000 constant read-mode
  $1001 constant write-mode
   : open >r fname here r> kernel32 OpenFile ~ current ! size ;

  :: read-mode open current @ { there } #size @ here 0 kernel32 ReadFile drop close ; is reload
  :: write-mode open current @ { there } #size @ here 0 kernel32 WriteFile ! drop close ; is save
;loc

: load use reload ;

: home kernel32 stdout 0 SetConsoleCursorPosition drop ;
: clear home 80 30 * for space next home ;
